/*
 * Copyright 2005-2009 WSO2, Inc. http://wso2.com
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

function addNewTab() {
    showInputDialog(jsi18n["what.should.be.tab.name"], addNewTabOkHandler, addNewTabCancelHandler);
}

function addNewTabCancelHandler() {
    return true;
}

function addNewTabOkHandler(tabTitle) {
    // Obtain a name for this new Tab
    if (tabTitle == null || tabTitle == "") {
        CARBON.showErrorDialog(jsi18n["no.tab.name"]);
        return;
    }

    var resp = UserPrefsService.addNewTab(userId, tabTitle, dashboardName);

    if(resp == 0) {
        CARBON.showErrorDialog(jsi18n["same.tab.name"]);
    }

    if (tabTitle == "") {
        tabTitle = "Tab " + resp;
    }

    if (resp) {
        // Deactivate all tabs
        var tabLinks = document.getElementById("tabmenu").getElementsByTagName("a");
        for (var x = 0; x < tabLinks.length; x++) {
            tabLinks[x].className = "";
        }

        // Create a new tab
        var tabMenu = document.getElementById("tabmenu");
        tabMenu.innerHTML =
        tabMenu.innerHTML + '<li onclick="makeActive(' + resp + ')"><a class="" id="tab' + resp +
        '">' + tabTitle + '</a></li>';

        // Clear existing tab content
        document.getElementById("page").innerHTML = ""

        // Updating the global pointer
        currentActiveTab = resp;

        // Making the new tab active
        makeActive(currentActiveTab);

    }
}

function duplicateActiveTab() {
    showInputDialog(jsi18n["what.should.be.tab.name"], duplicateActiveTabOkHandler, duplicateActiveTabCancelHandler);
}

function duplicateActiveTabOkHandler(tabTitle) {
    // Obtain a name for this new Tab
    if (tabTitle == null) {
        return;
    }

    var resp = UserPrefsService.duplicateTab(userId, dashboardName, currentActiveTab, tabTitle);

    if(resp == 0) {
        CARBON.showErrorDialog(jsi18n["same.tab.name"]);
    }

    if (tabTitle == "") {
        tabTitle = "Tab " + resp;
    }

    if (resp) {
        // Deactivate all tabs
        var tabLinks = document.getElementById("tabmenu").getElementsByTagName("a");
        for (var x = 0; x < tabLinks.length; x++) {
            tabLinks[x].className = "";
        }

        // Create a new tab
        var tabMenu = document.getElementById("tabmenu");
        tabMenu.innerHTML =
        tabMenu.innerHTML + '<li onclick="makeActive(' + resp + ')"><a class="" id="tab' + resp +
        '">' + tabTitle + '</a></li>';

        // Clear existing tab content
        document.getElementById("page").innerHTML = ""

        // Updating the global pointer
        currentActiveTab = resp;

        // Making the new tab active
        makeActive(currentActiveTab);

    }
}

function duplicateActiveTabCancelHandler() {
    return true;
}

function makeActive(tabId) {
    var tabLinks = document.getElementById("tabmenu").getElementsByTagName("a");
    for (var x = 0; x < tabLinks.length; x++) {
        tabLinks[x].className = "";
    }

    document.getElementById("tab" + tabId).className = "active";

    // Clear existing tab content
    document.getElementById("page").innerHTML = ""
    document.getElementById("page").style.display = ""

    document.getElementById("maximizedGadget").innerHTML = ""
    document.getElementById("maximizedGadget").style.display = "none"

    // Updating the global pointer
    currentActiveTab = tabId;

    // Set the container view to default
    gadgets.container.setView("default");

    // Load gadgets for the active tab
    loadGadgets(userId, currentActiveTab);
}

function loadGadgets(userId, tabId) {
    // Get the Gadget Layout
    gadgetserver.gadgetLayout = null;
    var gadgetGroup1 = new Array();
    var gadgetGroup2 = new Array();
    var gadgetGroup3 = new Array();

    var tempLayout = UserPrefsService.getGadgetLayout(userId, tabId, dashboardName).split(",");

    if (tempLayout[0] != "NA") {
        // We proceed only is we have gadgets for this tab. Otherwise do nothing.
        gadgetserver.gadgetLayout = tempLayout;

        for (var i = 0; i < gadgetserver.gadgetLayout.length; i++) {
            if (gadgetserver.gadgetLayout[i].split("#")[0] == "G1") {
                gadgetGroup1[gadgetGroup1.length] = gadgetserver.gadgetLayout[i].split("#")[1];
            } else if (gadgetserver.gadgetLayout[i].split("#")[0] == "G2") {
                gadgetGroup2[gadgetGroup2.length] = gadgetserver.gadgetLayout[i].split("#")[1];
            } else if (gadgetserver.gadgetLayout[i].split("#")[0] == "G3") {
                gadgetGroup3[gadgetGroup3.length] = gadgetserver.gadgetLayout[i].split("#")[1];
            }
        }

        // Get the Gadget spec URLs
        gadgetserver.gadgetSpecUrls =
        sanitizeUrls(UserPrefsService.getGadgetUrlsToLayout(userId, tabId, dashboardName));

        // Draw gadget Chromes
        var columnsDiv = document.getElementById("page");
        var chromeHTML = ""

        chromeHTML = chromeHTML + "<div id=\"group1\" class=\"section\"><div class=\"sectionTop\"></div>";

        for (var z = 0; z < gadgetGroup1.length; z++) {
            chromeHTML = chromeHTML + "<div id=\"gadget-chrome_" + gadgetGroup1[z] + "\" class=\"gadgets-gadget-chrome\"></div>";
        }

        chromeHTML = chromeHTML + "</div>";
        chromeHTML = chromeHTML + "<div id=\"group2\" class=\"section\"><div class=\"sectionTop\"></div>";

        for (var z = 0; z < gadgetGroup2.length; z++) {
            chromeHTML = chromeHTML + "<div id=\"gadget-chrome_" + gadgetGroup2[z] + "\" class=\"gadgets-gadget-chrome\"></div>";
        }

        chromeHTML = chromeHTML + "</div>";
        chromeHTML = chromeHTML + "<div id=\"group3\" class=\"section\"><div class=\"sectionTop\"></div>";

        for (var z = 0; z < gadgetGroup3.length; z++) {
            chromeHTML = chromeHTML + "<div id=\"gadget-chrome_" + gadgetGroup3[z] + "\" class=\"gadgets-gadget-chrome\"></div>";
        }

        chromeHTML = chromeHTML + "</div>";

        columnsDiv.innerHTML = chromeHTML;

        // When the DOM is ready init gadgets
        jQuery(document).ready(function() {
            jQuery("#page").show("slow");
            var settings = {};
            var portal;
            // Initialise the contianer
            gadgetserver.init();
            gadgetserver.renderGadgets();

            $(".section").sortable({
                connectWith : ['.section'],
                opacity : 0.7,
                revert : true,
                scroll : true,
                placeholder : 'block-hover',
                tolerance : 'pointer',
                update : function(event, ui) {
                    persistGadgetLayoutProto();
                }

            });

            drawOptionsButton();

        }

                );

    }
}

function removeActiveTab() {
      confirmDialog(jsi18n["remove.tab"], removeActiveTabAction, currentActiveTab)
}

function removeActiveTabAction(tabId) {
    if (currentActiveTab == 0) {
        CARBON.showErrorDialog(jsi18n["cannot.delete.tab"]);
    } else {
        var resp = UserPrefsService.removeTab(userId, currentActiveTab, dashboardName);

        if (resp) {
            // Refresh page
            window.location = 'index.jsp?name=' + dashboardName;
        } else {
            CARBON.showErrorDialog(jsi18n["failed.removing.active.tab"]);
        }
    }
}